package jp.co.y_net.amm.dao;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Example;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Component;


@Component("infDao")
public class InfDao extends AbstractDao {
    
    /* 参照形処理 ------------------------------------------------------------------------------------------------ */
    /** ユニークキーを使用した取得 */
    public Inf getByInfid(Integer infid) {
        Inf cnd = new Inf();
        cnd.setInfid(infid);
        List<Inf> list = get(cnd);
        if(list.size() == 1) {
            return list.get(0);
        }
        return null;
    }
    /** 全件取得(論理削除除外) */
    public List<Inf> get() {
        Inf cnd = new Inf();
        cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        return get(cnd);
    }
    /** 条件付き取得(論理削除除外) */
    public List<Inf> get(Inf cnd) {
        if(cnd != null) {
            cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        }
        HibernateTemplate hibernateTemplate = getHibernateTemplate();
        DetachedCriteria dc = DetachedCriteria.forClass(Inf.class);
        dc.add(Example.create(cnd));
        @SuppressWarnings("unchecked")
        List<Inf> list = (List<Inf>) hibernateTemplate.findByCriteria(dc);
        hibernateTemplate.clear();
        return list;
    }
    
    /* 更新系処理 ------------------------------------------------------------------------------------------------ */
    private static final String ENTITYNAME = "Inf";
    private static final String PKEYNAME = "infid";
    /**
     * 登録処理
     * ・必要なカラムを自動採番する
     * ・共通処理を実施する。
     * @param item
     */
    public void add(Inf item, Integer updateusrid) {
        /* 自動採番 */
        item.setInfid(getNextId(ENTITYNAME, PKEYNAME));
        /* Insert実施 */
        super.add(item, updateusrid);
    }
    public void update(Inf item, Integer updateusrid) {
        super.update(item, updateusrid);
    }
    public void removeLogical(Inf item, Integer updateusrid) {
        super.removeLogical(item, updateusrid);
    }


}
